#include "stdafx.h"
#include "spc700.h"
#include "apu.h"
#include "soundux.h"
#include "port.h"
#include "turbo.h"

void play(char* fname);
void info(char* str);

#define MAX_FILES	((DISP_Y/10)-1)	/* őt@C */

unsigned char vbuff[DISP_X * DISP_Y];	/* zVRAM */
int errno;				/* bWCug߂ɕKv */
char* err;				/* G[͂ɃbZ[WZbg */
int recover;				/* A\ȃG[H */
char files[MAX_FILES][32];		/* SPCt@CXg */
int n_files;				/* SPCt@C */
int cursel;				/* ݂̑It@CCfNX */

/*
    RAMւ̃R[h̃Rs[
*/
#define FRAMCOPY(dstsect,srcsect)\
{\
extern unsigned long __START_##dstsect[];\
extern unsigned long __START_##srcsect[];\
extern unsigned long __SIZEOF_##srcsect[];\
    memcpy(\
        &__START_##dstsect,\
        &__START_##srcsect,\
        (unsigned)&__SIZEOF_##srcsect\
    );\
}

/****************************************************************************/

void
pceAppInit()
{
	int retval, len;
	FILEINFO fi;

	/* ʓIȏB */
	pceLCDDispStop();
	pceLCDSetBuffer(vbuff);
	pceAppSetProcPeriod(100);
	pceLCDDispStart();

	/* SPCt@CT܂B */
	retval = pceFileFindOpen(&fi);
	if(retval != 0) {
		err = "pceFileFindOpen failed";
		recover = 0;
		return;
	}
	while(n_files < MAX_FILES) {
		retval = pceFileFindNext(&fi);
		if(!retval) break; /* Ȃ */
		if((len = strlen(fi.filename)) < 4) continue;
		if(strcmp(&fi.filename[len - 4], ".spc") != 0) continue;
		strcpy(files[n_files++], fi.filename);
	}
	pceFileFindClose(&fi);
	if(n_files == 0) {
		err = "SPCt@C܂";
		recover = 0;
		return;
	}
}

void
pceAppProc(int count)
{
	int retval, pad, i, x, y;

	/* pbhԎ擾ASELECT{^ŏIB */
	pad = pcePadGet();
	if(pad & TRG_SELECT) {
		pceAppReqExit(0);
		return;
	}

	/* ʃNAB */
	memset(vbuff, 0, sizeof vbuff);

	if(err != NULL) {
		/* G[bZ[W\B */
		pceFontSetType(0x80);
		pceFontSetTxColor(3);
		pceFontSetBkColor(-1);
		pceFontSetPos(0, 0);
		pceFontPutStr(err);

		/* G[H */
		if(recover) {
			if(pad & (TRG_A | TRG_B)) err = NULL;
		}

	} else {
		/* t@CIύXB */
		if(pad & TRG_UP && 0 < cursel) cursel--;
		if(pad & TRG_DN && cursel < n_files - 1) cursel++;

		/* ĐJnH */
		if(pad & TRG_A) {
			play(files[cursel]);
		}

		/* t@CXg\B */
		pceFontSetType(0x80);
		x = (DISP_X - 10 * 13) / 2;
		y = 0;
		pceFontSetTxColor(0);
		pceFontSetBkColor(3);
		pceFontSetPos(x, y);
		/*             OPQRSTUVWXOPQ*/
		pceFontPutStr("=====robvC[=====");
		x = 0;
		y += 10;
		pceFontSetBkColor(0);
		pceFontSetBkColor(-1);
		for(i = 0; i < n_files; i++) {
			if(i == cursel) {
				pceFontSetTxColor(0);
				pceFontSetBkColor(2);
			} else {
				pceFontSetTxColor(3);
				pceFontSetBkColor(-1);
			}
			pceFontSetPos(x, y);
			pceFontPutStr(files[i]);
			y += 10;
		}
	}

	/* ʓ]B */
	pceLCDTrans();
}

void
pceAppExit()
{
}

/****************************************************************************/

#define BLOCKSIZE	4096

int
file_read(FILEACC* fa, void* ptr, int ofs, int len)
{
	int i, sct, sof, sln;
	char* p = (char*)ptr;

	i = 0;
	while(i < len) {
		/* ZN^̃tbVAhX擾܂B */
		sct = (ofs + i) / BLOCKSIZE;			/* sct = ݂̓ǂݍ݃ItZbg܂ރZN^ԍ                         */
		sln = pceFileReadSct(fa, NULL, sct, BLOCKSIZE);	/* sln = ̃ZN^̃f[^TCY(ŏIZN^̂sln<=BLOCKSIZEɂȂ܂) */
		if(sln == 0) break;				/* ԂItZbg                                                   */

		/* ̃ZN^ǂݍރTCY肵܂B */
		sof = (ofs + i) % BLOCKSIZE;			/* ZN^ItZbg                                                       */
		sln -= sof;					/* ZN^ItZbgȍ~ǂݍ݉\ȍőf[^TCY                 */
		if(sln > len - i) sln = len - i;		/* ǂݍ݉\ȍőf[^TCYcǂݍ݃TCYȏȂA؂l߂܂ */
		if(sln <= 0) break;				/* ԂItZbg߁A܂͓ǂݍ݃TCY0ȉw肳ꂽ(len<=0)    */

		/* ZN^obt@֓ǂݍ݂܂B */
		memcpy(p + i, fa->aptr + sof, sln);
		i += sln;
	}

	return i;
}

void
play(char* fname)
{
	info("");

	/* ʍő */
	pceWaveSetMasterAtt(0);
	pceWaveSetChAtt(0, 0);

	/* 48MHz */
	TurboON();

	/* ROM/RAM 1wait */
	*(short*)0x48126 = 0x6011;/*0x6012*/
	*(short*)0x4812a = 0x1111;/*0x1112*/

	/* RAM] */
	FRAMCOPY(V_FRAMC, soundux_code);

	/* tJn */
	if(LoadSPC(fname)) {
		PlaySPC();
	}
	for(;;) { } /* ߂܂I */
}

void
info(char* str)
{
	static char msg[100];

	memset(vbuff, 0, sizeof vbuff);
	pceFontSetType(0x00);
	pceFontSetPos(0, 0);
	pceFontSetTxColor(3);
	pceFontSetBkColor(-1);
	strcpy(msg, "Iɂ͔wʂ̃ZbgĂB\n\n");
	strcat(msg, str);
	pceFontPutStr(msg);
	pceLCDTrans();
}
