#ifndef _TURBO_H_
#define _TURBO_H_

// 24MHz/48MHzؑ֓ݒI/O|[g
#define	port_P0x	(*(volatile unsigned char*)0x402D1)

// 16bit^C}n 䃌WX^
#define reg_TC0		(*(volatile unsigned short int*)0x48186)
#define reg_TC1		(*(volatile unsigned short int*)0x4818E)
#define reg_TC4		(*(volatile unsigned short int*)0x481A6)

// 16bit^C}0 RyAf[^B ݒ背WX^ (1ms^C}) ftHg=5999
#define reg_CR0B	(*(volatile unsigned short int*)0x48182)

// 16bit^C}x NbNRg[WX^
#define reg_CC1	(*(volatile unsigned char*)0x40148)
#define reg_CC4	(*(volatile unsigned char*)0x4014B)

void TurboH_StopTimer(void){
	reg_TC0 &= ~4;  reg_TC1 &= ~4; reg_TC4 &= ~4;
}
void TurboH_StartTimer(void){
	reg_TC0 |= 4;   reg_TC1 |= 4;  reg_TC4 |= 4;
}

void TurboON(void){
	TurboH_StopTimer();	// JEgꎞ~
	port_P0x &= ~0x80;	// x[XNbN48MHz.
				       // x[XNbN//RyAf[^
	reg_CR0B = 11999;  		    	// 48MHz/4/12000 = 1kHz  (1msJE^)
	reg_CC1  = (reg_CC1 & ~0x7) | 1;	// 48MHz/2/750   = 32kHz (PWMp)
	reg_CC4  = (reg_CC4 & ~0x7) | 1;	// 48MHz/2/4     = 6MHz (USBpNbN)
	TurboH_StartTimer();	// JEgJn
}

void TurboOFF(void){
	TurboH_StopTimer();	// JEgꎞ~
	port_P0x |=  0x80;	// x[XNbN24MHz.
	reg_CR0B = 5999;			// 24MHz/4/6000  = 1kHz  (1msJE^)
	reg_CC1  = (reg_CC1 & ~0x7) | 0;	// 24MHz/1/750   = 32kHz (PWMp)
	reg_CC4  = (reg_CC4 & ~0x7) | 0;	// 24MHz/1/4     = 6MHz (USBpNbN)
	TurboH_StartTimer();	// JEgJn
}

#endif
